
#include <ATM8F8040K.H>
#include "main.h"
#include "api_ext.h"

/***********************Delay****************************************/
//sysclk 4MHz ʱ1ms
void Delay_1ms(unsigned int Del_1ms)		//
{
	unsigned char j;
	while(Del_1ms--)
	{	
		for(j=0;j<80;j++);
	}
}

void main(void)
{
	system_init();
	#ifdef IO_TEST
	IO_Test();  /*IO ת*/
	#endif	
	#ifdef ADC_TEST
	ADC_Test();			//uart0 յ'0'.......'B'һADCӦͨתֵͨuart0ͳ
	#endif
	#ifdef UART0_TEST
	Uart0_Test();		//9600,P03->TX,P04->RX ,ͽյ
	#endif
	#ifdef UART1_TEST
	Uart1_Test();		//9600,P21->TX,P17->RX ,ͽյ
	#endif
	#ifdef TIMER0_TEST
	Timer0_Test();	//P02ת,Ƶ500HZ,ģʽ3P03ͬʱ500HZ*/
	#endif
	#ifdef TIMER2_TEST
	Timer2_Test();	//16λԶģʽP0210KHZ
	#endif
	#ifdef PWM_TEST
	PWM_Test();			//P1.2P1.3һԻPWMռձ30%,P1.41ߵƽ,P1.6ռձλ70%,P0.2ռձλ50%
	#endif
	#ifdef LPC_TEST
	LPC_Test();     //͹ģʽʾ
	#endif
	#ifdef EINT_TEST
	EINT_Test();     //ⲿжʾ
	#endif
	#ifdef WAKEUP_TEST
	WAKEUP_Test();     //WDT,WT,EINTʾ
	#endif
	#ifdef CRC_TEST
	CRC_Test();     //0ӣ9ݣУֵ
	#endif
	#ifdef CPL_TEST
	CPL_Test();     //ģʽT0ⲿʱ(P07)Ϊͨ3룬CPL(P13)T0Ĳһ
	#endif
	#ifdef BUZ_TEST
	Buz_Test();     //P0.216KHZ
	#endif
	#ifdef IAP_TEST
	IAP_Test();   //eg:յ 0xa5 0x10 0x47ʾ0x10ַд0x47   eg:յ 0xaa 0x10 0xxxʾȡ0x10ַ
	#endif

	while(1);
}
