#include <ATM8F8040K.H>
#include "main.h"
#include "uart0.h"

#define UART0_MODE1 //λɱ䲨
//#define UART0_MODE3	//λɱ䲨żУ

sbit TB8 = S0CON ^ 3;
sbit RB8 = S0CON ^ 2;

#ifdef UART0_MODE1
#define Baud_EN		//ԤʹʷעʹT1Ϊʷ

//ϵͳʱĬ32/8=4MHz
void Uart0_Init(void)
{
	//IO TX -> P0.3 RX -> P0.4
	P0CR |= SET_BIT3;
	P0CR &= CLR_BIT4;
	P0PCR |= SET_BIT4;
	P0SELH |= 0x03;		//ѡù
	P0SELL |= 0xC0;	
	
	#ifdef Baud_EN
	{
		//ʹʷ 2*4Mhz/64/13=9615  9600
		//BAUD = (2^SMOD)*FCLK/(64*(2^10 - S0REL)) 
		//FCLKΪϵͳʱ
		S0RELH = 0x03;
		S0RELL = 0xF3;
		PCON |= 0xC0; //ʹʷ
	}
	#else
	{
		PCON |= 0x80;
		//ʹT1ʷ 2*(32/4/4=2)Mhz/32/139600
		//BAUD = (2^SMOD)/32 * FCLK/(TIMER1_OVERFLOW)
		//FCLKΪT1ʱ
		TH1 = 0xF3;
		TL1 = 0xF3;
		SYSDIV_4;	//ϵͳʱ4Ƶ32/4=8Mhz
		TIMPRS |= 1 << 4; //ʱ1ʱ4Ƶ8/4=2Mhz
		TMOD |= 2 << 4;		//ʱѡģʽ2
		TR1 = 1;
	}
	#endif
	//ʹuart0 ģʽ1
	S0CON = 0x50;
	IE_UART0_enable;
	EA = 1;
}


/*һֽ*/
void sendChar(uint8_t TxChar)
{
	S0BUF = TxChar;
	//ѯģʽ
	while(!(S0CON & 0x02));  	//ȴɱ־1
		S0CON	^= 0x02;							//ɱ־
}
/*һַ*/
void sendString(uint8_t *TxStr)
{
	while((*TxStr) != '\0')	//ַΪ\0
	{
		sendChar(*TxStr);			//͵ǰַַָָ
		TxStr++;							//ַָ1
	}
}

/*պ*/
void receive(uint8_t *rc,uint8_t count)
{
	while(count--)
	{
		while(~S0CON & 0x01);
		S0CON ^= 0x01;
		*rc = S0BUF;
		rc++;
	}
}

/*յݷͳ*/
void Uart0_Test(void)
{
	Uart0_Init();
	while(1)
	{
		/*Ӧжн*/
	}
}

void UART0_INT(void)	interrupt 4
{
	#ifdef UART0_TEST
	uint8_t temp;
	if(S0CON & 0x01)
	{
		S0CON ^= 0x01;	
		/*
		û
		*/
		temp = S0BUF;
		sendChar(temp);
	}	
	#endif
}
#endif

#ifdef UART0_MODE3

//ϵͳʱĬ32/8=4MHz
void Uart0_Init(void)
{
	//IO TX -> P0.3 RX -> P0.4
	P0CR |= SET_BIT3;
	P0CR &= CLR_BIT4;
	P0PCR |= SET_BIT4;
	P0SELH |= 0x03;		//ѡù
	P0SELL |= 0xC0;	
	
		//ʹʷ 2*4Mhz/64/13=9615  9600
		//BAUD = (2^SMOD)*FCLK/(64*(2^10 - S0REL)) 
		//FCLKΪϵͳʱ
		S0RELH = 0x03;
		S0RELL = 0xF3;
		PCON |= 0xC0; //ʹʷ

	//ʹuart0 ģʽ3
	S0CON = 0xD0;
	IE_UART0_enable;
	EA = 1;
}


/*һֽ*/
void sendChar(uint8_t TxChar)
{
	ACC = TxChar;
	TB8 = P;
	S0BUF = TxChar;
	//ѯģʽ
	while(!(S0CON & 0x02));  	//ȴɱ־1
		S0CON	^= 0x02;							//ɱ־
}
/*һַ*/
void sendString(uint8_t *TxStr)
{
	while((*TxStr) != '\0')	//ַΪ\0
	{
		sendChar(*TxStr);			//͵ǰַַָָ
		TxStr++;							//ַָ1
	}
}

/*պ*/
void receive(uint8_t *rc,uint8_t count)
{
	while(count--)
	{
		while(~S0CON & 0x01);
		S0CON ^= 0x01;
		*rc = S0BUF;
		rc++;
	}
}

/*յݷͳ*/
void Uart0_Test(void)
{
	Uart0_Init();
	while(1)
	{
		/*Ӧжн*/
	}
}

void UART0_INT(void)	interrupt 4
{
	#ifdef UART0_TEST
	uint8_t temp;
	if(S0CON & 0x01)
	{
		S0CON ^= 0x01;	
		/*
		û
		*/
		temp = S0BUF;
		ACC = temp;
		if(P == RB8)
			sendChar(temp);
	}	
	#endif
}

#endif